In Next.js and React, a page is a React Component exported from a file in the pages directory. Each page is associated with a route based on its file name. For example:

```js
// here you wanna import components, libraries, and variables

export default function Page() {
  // here you can add functions and hooks
  return (
    <>
      Here you can add components and content
    </>
  );
}
```

So, for example when we want to add `CardanoWallet` UI component, and the `useWallet()` hook, we do this:

```js
import { CardanoWallet, useWallet } from '@meshsdk/react';

export default function Page() {
  const { wallet, connected } = useWallet();

  return (
    <>
      {
        !connected && (
          <CardanoWallet />
        )
      }
    </>
  );
}
```

This will render the `CardanoWallet` component when the user is not connected to a wallet.

We will also want to separate some UI into components, you can either create a `components` folder and add a `WhenConnected.tsx` file, or create the component directly in the page file.

```js
import { CardanoWallet, useWallet } from '@meshsdk/react';

export default function Page() {
  const { wallet, connected } = useWallet();

  return (
    <>
      {
        !connected && (
          <CardanoWallet />
        )
      }
      {
        connected && (
          <WhenConnected />
        )
      }
    </>
  );
}

function WhenConnected(){
  return (
    <>
      <h1>Connected!</h1>
    </>
  );
}
```

This will render the `CardanoWallet` component when the user is not connected to a wallet, and the `WhenConnected` component when the user is connected.

Next, we want to add those functions we created in our previous lesson:

```js
import { CardanoWallet, useWallet } from '@meshsdk/react';

export default function Page() {
  const { wallet, connected } = useWallet();

  return (
    <>
      {
        !connected && (
          <CardanoWallet />
        )
      }
      {
        connected && (
          <WhenConnected />
        )
      }
    </>
  );
}

function WhenConnected(){

  async function lockAsset() {
    ...
  }

  async function redeemAsset() {
    ...
  }

  return (
    <>
      <h1>Connected!</h1>
    </>
  );
}
```

Next, we want to add buttons to trigger these functions:

```js
function WhenConnected(){

  async function lockAsset() {
    ...
  }

  async function redeemAsset() {
    ...
  }

  return (
    <>
      <h1>Connected!</h1>

      <button
        type="button"
        onClick={() => lockAsset()}
      >
        Lock Asset
      </button>

      <button
        type="button"
        onClick={() => redeemAsset()}
      >
        Redeem Asset
      </button>
    </>
  );
}
```

Give it a try! You should be able to lock and redeem assets now by clicking the buttons.

Next, we want to add some state to our component to show the user the status of the transaction. We can do this with the `useState` hook. When the `state` is `1`, we show the user that the transaction is being processed, and we disable the button from being clicked again.

```js
import { useState } from "react";

function WhenConnected(){

  const [state, setState] = useState(0);

  async function lockAsset() {
    setState(1);
    ...
    setState(0);
  }

  async function redeemAsset() {
    setState(1);
    ...
    setState(0);
  }

  return (
    ...
  );
}
```


If you would like to, we can display the transaction hash to the user with another state variable:

```js
function WhenConnected(){

  const [state, setState] = useState(0);
  const [submittedTxHash, setSubmittedTxHash] = useState("");

  async function lockAsset() {
    setState(1);

    ...

    const txHash = await wallet.submitTx(signedTx);
    setSubmittedTxHash(txHash)

    setState(0);
  }

  async function redeemAsset() {
    setState(1);
    ...

    const txHash = await wallet.submitTx(signedTx);
    setSubmittedTxHash(txHash)

    setState(0);
  }

  return (
    <>
      ...
      <p>
        Submitted Tx Hash: {submittedTxHash}
      </p>
    </>
  );
}
```

You will realized that, after we have submitted the transaction, we do not know when the transaction is confirmed. We can use the [onTxConfirmed()](https://meshjs.dev/providers/koios#onTxConfirmed) event to listen for the transaction confirmation.

```js
import { KoiosProvider } from "@meshsdk/core";

function WhenConnected(){

  const [state, setState] = useState(0);
  const [submittedTxHash, setSubmittedTxHash] = useState("");

  async function lockAsset() {
    setState(1);

    ...

    const txHash = await wallet.submitTx(signedTx);
    setSubmittedTxHash(txHash)

    const blockchainProvider = new KoiosProvider("preprod");
    blockchainProvider.onTxConfirmed(txHash, () => {
      setState(0);
    });
  }

  return (
    <>
      ...
    </>
  )
}
```

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
